//	WinDjView
//	Copyright (C) 2004-2012 Andrew Zhezherun
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//	http://www.gnu.org/copyleft/gpl.html

//////////////////////////////////////////////////////////////////////
// Copyright (C) Microsoft Corporation. All rights reserved.
// Windows XP theme API

#pragma once

#ifndef WM_THEMECHANGED
#define WM_THEMECHANGED     0x031A
#endif

bool IsThemed();

HTHEME XPOpenThemeData(HWND hwnd, LPCWSTR pszClassList);
HRESULT XPCloseThemeData(HTHEME hTheme);
HRESULT XPDrawThemeBackground(HTHEME hTheme, HDC hdc,
    int iPartId, int iStateId, const RECT* pRect, const RECT* pClipRect);
HRESULT XPDrawThemeText(HTHEME hTheme, HDC hdc, int iPartId,
    int iStateId, LPCWSTR pszText, int iCharCount, DWORD dwTextFlags,
    DWORD dwTextFlags2, const RECT* pRect);
HRESULT XPGetThemeBackgroundContentRect(HTHEME hTheme, HDC hdc,
    int iPartId, int iStateId,  const RECT* pBoundingRect,
    OUT RECT* pContentRect);
HRESULT XPGetThemeBackgroundExtent(HTHEME hTheme, HDC hdc,
    int iPartId, int iStateId, const RECT* pContentRect,
    OUT RECT* pExtentRect);
HRESULT XPGetThemePartSize(HTHEME hTheme, HDC hdc, int iPartId,
    int iStateId, RECT* prc, THEMESIZE eSize, OUT SIZE* psz);
HRESULT XPGetThemeTextExtent(HTHEME hTheme, HDC hdc,
    int iPartId, int iStateId, LPCWSTR pszText, int iCharCount,
    DWORD dwTextFlags, const RECT* pBoundingRect,
    OUT RECT* pExtentRect);
HRESULT XPGetThemeTextMetrics(HTHEME hTheme, HDC hdc,
    int iPartId, int iStateId, OUT TEXTMETRIC* ptm);
HRESULT XPGetThemeBackgroundRegion(HTHEME hTheme, HDC hdc,
    int iPartId, int iStateId, const RECT* pRect, OUT HRGN* pRegion);
HRESULT XPHitTestThemeBackground(HTHEME hTheme, HDC hdc, int iPartId,
    int iStateId, DWORD dwOptions, const RECT* pRect, HRGN hrgn,
    POINT ptTest, OUT WORD* pwHitTestCode);
HRESULT XPDrawThemeEdge(HTHEME hTheme, HDC hdc, int iPartId,
	int iStateId, const RECT* pDestRect, UINT uEdge, UINT uFlags, OUT RECT* pContentRect);
HRESULT XPDrawThemeIcon(HTHEME hTheme, HDC hdc, int iPartId,
    int iStateId, const RECT* pRect, HIMAGELIST himl, int iImageIndex);
BOOL XPIsThemePartDefined(HTHEME hTheme, int iPartId,
    int iStateId);
BOOL XPIsThemeBackgroundPartiallyTransparent(HTHEME hTheme,
    int iPartId, int iStateId);
HRESULT XPGetThemeColor(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT COLORREF* pColor);
HRESULT XPGetThemeMetric(HTHEME hTheme, HDC hdc, int iPartId,
    int iStateId, int iPropId, OUT int* piVal);
HRESULT XPGetThemeString(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT LPWSTR pszBuff, int cchMaxBuffChars);
HRESULT XPGetThemeBool(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT BOOL* pfVal);
HRESULT XPGetThemeInt(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT int* piVal);
HRESULT XPGetThemeEnumValue(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT int* piVal);
HRESULT XPGetThemePosition(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT POINT* pPoint);
HRESULT XPGetThemeFont(HTHEME hTheme, HDC hdc, int iPartId,
    int iStateId, int iPropId, OUT LOGFONTW* pFont);
HRESULT XPGetThemeRect(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT RECT* pRect);
HRESULT XPGetThemeMargins(HTHEME hTheme, HDC hdc, int iPartId,
    int iStateId, int iPropId, RECT* prc, OUT MARGINS* pMargins);
HRESULT XPGetThemeIntList(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT INTLIST* pIntList);
HRESULT XPGetThemePropertyOrigin(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT PROPERTYORIGIN* pOrigin);
HRESULT XPSetWindowTheme(HWND hwnd, LPCWSTR pszSubAppName,
    LPCWSTR pszSubIdList);
HRESULT XPGetThemeFilename(HTHEME hTheme, int iPartId,
    int iStateId, int iPropId, OUT LPWSTR pszThemeFileName, int cchMaxBuffChars);
COLORREF XPGetThemeSysColor(HTHEME hTheme, int iColorId);
HBRUSH XPGetThemeSysColorBrush(HTHEME hTheme, int iColorId);
BOOL XPGetThemeSysBool(HTHEME hTheme, int iBoolId);
int XPGetThemeSysSize(HTHEME hTheme, int iSizeId);
HRESULT XPGetThemeSysFont(HTHEME hTheme, int iFontId, OUT LOGFONTW* plf);
HRESULT XPGetThemeSysString(HTHEME hTheme, int iStringId,
    OUT LPWSTR pszStringBuff, int cchMaxStringChars);
HRESULT XPGetThemeSysInt(HTHEME hTheme, int iIntId, int* piValue);
BOOL XPIsThemeActive();
BOOL XPIsAppThemed();
HTHEME XPGetWindowTheme(HWND hwnd);
HRESULT XPEnableThemeDialogTexture(HWND hwnd, DWORD dwFlags);
BOOL XPIsThemeDialogTextureEnabled(HWND hwnd);
DWORD XPGetThemeAppProperties();
void XPSetThemeAppProperties(DWORD dwFlags);
HRESULT XPGetCurrentThemeName(
    OUT LPWSTR pszThemeFileName, int cchMaxNameChars,
    OUT LPWSTR pszColorBuff, int cchMaxColorChars,
    OUT LPWSTR pszSizeBuff, int cchMaxSizeChars);
HRESULT XPGetThemeDocumentationProperty(LPCWSTR pszThemeName,
    LPCWSTR pszPropertyName, OUT LPWSTR pszValueBuff, int cchMaxValChars);
HRESULT XPDrawThemeParentBackground(HWND hwnd, HDC hdc, RECT* prc);
HRESULT XPEnableTheming(BOOL fEnable);
HRESULT XPDrawThemeBackgroundEx(HTHEME hTheme, HDC hdc,
    int iPartId, int iStateId, const RECT* pRect, const DTBGOPTS* pOptions);

